/* Generated by re2c */
// re2c $INPUT -o $OUTPUT -i
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>



typedef struct mtag_t {
    struct mtag_t *pred;
    long dist;
} mtag_t;

typedef struct mtagpool_t {
    mtag_t *head;
    mtag_t *next;
    mtag_t *last;
} mtagpool_t;

typedef struct {
    FILE *file;
    char *buf;
    char *lim;
    char *cur;
    char *mar;
    char *tok;
    char *yyt1;
char *yyt10;
char *yyt11;
char *yyt12;
char *yyt13;
char *yyt14;
char *yyt15;
char *yyt16;
char *yyt17;
char *yyt18;
char *yyt19;
char *yyt2;
char *yyt20;
char *yyt21;
char *yyt22;
char *yyt23;
char *yyt24;
char *yyt25;
char *yyt26;
char *yyt27;
char *yyt28;
char *yyt29;
char *yyt3;
char *yyt30;
char *yyt4;
char *yyt5;
char *yyt6;
char *yyt7;
char *yyt8;
char *yyt9;

    mtag_t *yytm31;
mtag_t *yytm32;
mtag_t *yytm33;
mtag_t *yytm34;
mtag_t *yytm35;
mtag_t *yytm36;
mtag_t *yytm37;

    mtagpool_t mtp;
    int eof;
} input_t;

static void mtagpool_clear(mtagpool_t *mtp, input_t *in)
{
    mtp->next = mtp->head;
    in->yytm31 = 0;
in->yytm32 = 0;
in->yytm33 = 0;
in->yytm34 = 0;
in->yytm35 = 0;
in->yytm36 = 0;
in->yytm37 = 0;

}

static void mtagpool_init(mtagpool_t *mtp)
{
    static const unsigned size = 1024 * 1024;
    mtp->head = (mtag_t*)malloc(size * sizeof(mtag_t));
    mtp->next = mtp->head;
    mtp->last = mtp->head + size;
}

static void mtagpool_free(mtagpool_t *mtp)
{
    free(mtp->head);
    mtp->head = mtp->next = mtp->last = NULL;
}

static mtag_t *mtagpool_next(mtagpool_t *mtp)
{
    unsigned size;
    mtag_t *head;

    if (mtp->next < mtp->last) return mtp->next++;

    size = mtp->last - mtp->head;
    head = (mtag_t*)malloc(2 * size * sizeof(mtag_t));
    memcpy(head, mtp->head, size * sizeof(mtag_t));
    free(mtp->head);
    mtp->head = head;
    mtp->next = head + size;
    mtp->last = head + size * 2;
    return mtp->next++;
}

static void mtag(mtag_t **pmt, const char *b, const char *t, mtagpool_t *mtp)
{
    mtag_t *mt = mtagpool_next(mtp);
    mt->pred = *pmt;
    mt->dist = t - b;
    *pmt = mt;
}

#define YYMAXFILL 66

static const size_t SIZE = 4096;

static void init_input(input_t *in, const char *fname)
{
    in->file = fopen(fname, "r");
    in->buf = (char*) malloc(SIZE + YYMAXFILL);
    in->lim = in->buf + SIZE;
    in->cur = in->lim;
    in->mar = in->lim;
    in->tok = in->lim;
    in->yyt1 = 0;
in->yyt10 = 0;
in->yyt11 = 0;
in->yyt12 = 0;
in->yyt13 = 0;
in->yyt14 = 0;
in->yyt15 = 0;
in->yyt16 = 0;
in->yyt17 = 0;
in->yyt18 = 0;
in->yyt19 = 0;
in->yyt2 = 0;
in->yyt20 = 0;
in->yyt21 = 0;
in->yyt22 = 0;
in->yyt23 = 0;
in->yyt24 = 0;
in->yyt25 = 0;
in->yyt26 = 0;
in->yyt27 = 0;
in->yyt28 = 0;
in->yyt29 = 0;
in->yyt3 = 0;
in->yyt30 = 0;
in->yyt4 = 0;
in->yyt5 = 0;
in->yyt6 = 0;
in->yyt7 = 0;
in->yyt8 = 0;
in->yyt9 = 0;

    in->yytm31 = 0;
in->yytm32 = 0;
in->yytm33 = 0;
in->yytm34 = 0;
in->yytm35 = 0;
in->yytm36 = 0;
in->yytm37 = 0;

    mtagpool_init(&in->mtp);
    in->eof = 0;
}

static void free_input(input_t *in)
{
    fclose(in->file);
    free(in->buf);
    mtagpool_free(&in->mtp);
}

static int fill(input_t *in, size_t need)
{
    size_t free;
    if (in->eof) return 1;

    free = in->tok - in->buf;
    if (free < need) return 2;

    memmove(in->buf, in->tok, in->lim - in->tok);
    in->lim -= free;
    in->cur -= free;
    in->mar -= free;
    in->tok -= free;
    if (in->yyt1) in->yyt1 -= free;
if (in->yyt10) in->yyt10 -= free;
if (in->yyt11) in->yyt11 -= free;
if (in->yyt12) in->yyt12 -= free;
if (in->yyt13) in->yyt13 -= free;
if (in->yyt14) in->yyt14 -= free;
if (in->yyt15) in->yyt15 -= free;
if (in->yyt16) in->yyt16 -= free;
if (in->yyt17) in->yyt17 -= free;
if (in->yyt18) in->yyt18 -= free;
if (in->yyt19) in->yyt19 -= free;
if (in->yyt2) in->yyt2 -= free;
if (in->yyt20) in->yyt20 -= free;
if (in->yyt21) in->yyt21 -= free;
if (in->yyt22) in->yyt22 -= free;
if (in->yyt23) in->yyt23 -= free;
if (in->yyt24) in->yyt24 -= free;
if (in->yyt25) in->yyt25 -= free;
if (in->yyt26) in->yyt26 -= free;
if (in->yyt27) in->yyt27 -= free;
if (in->yyt28) in->yyt28 -= free;
if (in->yyt29) in->yyt29 -= free;
if (in->yyt3) in->yyt3 -= free;
if (in->yyt30) in->yyt30 -= free;
if (in->yyt4) in->yyt4 -= free;
if (in->yyt5) in->yyt5 -= free;
if (in->yyt6) in->yyt6 -= free;
if (in->yyt7) in->yyt7 -= free;
if (in->yyt8) in->yyt8 -= free;
if (in->yyt9) in->yyt9 -= free;

    in->lim += fread(in->lim, 1, free, in->file);
    if (in->lim < in->buf + SIZE) {
        in->eof = 1;
        memset(in->lim, 0, YYMAXFILL);
        in->lim += YYMAXFILL;
    }
    return 0;
}

static void print_headers(const char *tok,
    const mtag_t *h1, const mtag_t *h2,
    const mtag_t *h3, const mtag_t *h4,
    const mtag_t *h5)
{
    if (!h1) return;
    print_headers(tok, h1->pred, h2->pred, h3->pred, h4->pred, h5->pred);
    fprintf(stderr, "%.*s%.*s%.*s%.*s\n",
        (int)(h2->dist - h1->dist), tok + h1->dist,
        (int)(h3->dist - h2->dist), tok + h2->dist,
        (int)(h4->dist - h3->dist), tok + h3->dist,
        (int)(h5->dist - h4->dist), tok + h4->dist);
}

#define YYCTYPE        char
#define YYCURSOR       in->cur
#define YYMARKER       in->mar
#define YYLIMIT        in->lim
#define YYMTAGP(mt)    mtag(&mt, in->tok, in->cur, &in->mtp)
#define YYMTAGN(mt)    mtag(&mt, in->tok, NULL, &in->mtp)
#define YYFILL(n)      if (fill(in, n) != 0) return 2;

static int lex(input_t *in, long *count)
{
    const char *of, *au, *at,
        *hs1, *hs3, *m1, *p1, *p3, *p5, *q1, *q3,
        *hs2, *hs4, *m2, *p2, *p4, *p6, *q2, *q4,
        *r1, *r3, *rp1, *s1, *st1, *u1, *u3, *v1, *v3,
        *r2, *r4, *rp2, *s2, *st2, *u2, *u4, *v2, *v4;
    mtag_t *h1, *h2, *h3, *h4, *h5;
    long c;

    c = 0;;
    of = au = at
        = hs1 = hs3 = m1 = p1 = p3 = p5 = q1 = q3
        = hs2 = hs4 = m2 = p2 = p4 = p6 = q2 = q4
        = r1 = r3 = rp1 = s1 = st1 = u1 = u3 = v1 = v3
        = r2 = r4 = rp2 = s2 = st2 = u2 = u4 = v2 = v4 = NULL;
loop:
    in->tok = in->cur;

{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 66) YYFILL(66);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00: goto yy1;
		case '\n': goto yy4;
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~':
			in->yyt1 = YYCURSOR;
			goto yy5;
		case 'H':
			in->yyt1 = YYCURSOR;
			goto yy6;
		default: goto yy2;
	}
yy1:
	++YYCURSOR;
	{ *count = c; return 0; }
yy2:
	++YYCURSOR;
yy3:
	{ return 1; }
yy4:
	++YYCURSOR;
	{ goto loop; }
yy5:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
		case ' ':
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~': goto yy10;
		default: goto yy3;
	}
yy6:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
		case ' ':
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~': goto yy10;
		case 'T': goto yy11;
		default: goto yy3;
	}
yy7:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = YYCURSOR;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = YYCURSOR;
			in->yyt11 = YYCURSOR;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case '_':
		case '~':
			in->yyt3 = YYCURSOR;
			in->yyt4 = NULL;
			in->yyt5 = YYCURSOR;
			in->yyt9 = NULL;
			in->yyt10 = YYCURSOR;
			goto yy13;
		case '%':
			in->yyt3 = YYCURSOR;
			in->yyt4 = NULL;
			in->yyt5 = YYCURSOR;
			in->yyt9 = NULL;
			in->yyt10 = YYCURSOR;
			goto yy14;
		case '/':
			in->yyt26 = YYCURSOR;
			goto yy15;
		case ':':
			in->yyt3 = YYCURSOR;
			in->yyt4 = NULL;
			in->yyt5 = YYCURSOR;
			in->yyt9 = NULL;
			in->yyt10 = YYCURSOR;
			in->yyt11 = YYCURSOR;
			goto yy16;
		case '?':
			in->yyt26 = YYCURSOR;
			in->yyt27 = YYCURSOR;
			goto yy17;
		case '@':
			in->yyt3 = YYCURSOR;
			in->yyt5 = YYCURSOR;
			in->yyt9 = YYCURSOR;
			goto yy18;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
			in->yyt3 = YYCURSOR;
			in->yyt4 = NULL;
			in->yyt5 = YYCURSOR;
			in->yyt9 = NULL;
			in->yyt10 = YYCURSOR;
			in->yyt13 = YYCURSOR;
			goto yy19;
		case '[':
			in->yyt3 = YYCURSOR;
			in->yyt4 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = YYCURSOR;
			goto yy20;
		default: goto yy8;
	}
yy8:
	YYCURSOR = YYMARKER;
	goto yy3;
yy9:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 62) YYFILL(62);
	yych = *YYCURSOR;
yy10:
	switch (yych) {
		case ' ':
			in->yyt2 = YYCURSOR;
			goto yy7;
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~': goto yy9;
		default: goto yy8;
	}
yy11:
	yych = *++YYCURSOR;
	switch (yych) {
		case 'T': goto yy21;
		default: goto yy10;
	}
yy12:
	yych = *++YYCURSOR;
	switch (yych) {
		case 'H': goto yy22;
		default: goto yy8;
	}
yy13:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 61) YYFILL(61);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt11 = YYCURSOR;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy13;
		case '%': goto yy14;
		case ':':
			in->yyt11 = YYCURSOR;
			goto yy16;
		case '@':
			in->yyt9 = YYCURSOR;
			goto yy18;
		default: goto yy8;
	}
yy14:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy23;
		default: goto yy8;
	}
yy15:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 12) YYFILL(12);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt27 = YYCURSOR;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '/':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case '@':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy15;
		case '%': goto yy24;
		case '?':
			in->yyt27 = YYCURSOR;
			goto yy17;
		default: goto yy8;
	}
yy16:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt5 = YYCURSOR;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt12 = YYCURSOR;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			in->yyt12 = YYCURSOR;
			goto yy28;
		default: goto yy26;
	}
yy17:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = YYCURSOR;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt28 = YYCURSOR;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '/':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case '?':
		case '@':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~':
			in->yyt28 = YYCURSOR;
			goto yy29;
		case '%':
			in->yyt28 = YYCURSOR;
			goto yy30;
		default: goto yy8;
	}
yy18:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt4 = in->yyt5;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt10 = YYCURSOR;
			in->yyt11 = YYCURSOR;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~':
			in->yyt10 = YYCURSOR;
			goto yy31;
		case '%':
			in->yyt10 = YYCURSOR;
			goto yy32;
		case ':':
			in->yyt10 = YYCURSOR;
			in->yyt11 = YYCURSOR;
			goto yy33;
		case '[':
			in->yyt4 = in->yyt5;
			in->yyt10 = YYCURSOR;
			goto yy20;
		default: goto yy8;
	}
yy19:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 65) YYFILL(65);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt11 = YYCURSOR;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case ',':
		case ';':
		case '=':
		case '_':
		case '~': goto yy13;
		case '%': goto yy14;
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': goto yy19;
		case ':':
			in->yyt11 = YYCURSOR;
			in->yyt14 = YYCURSOR;
			goto yy34;
		case '@':
			in->yyt9 = YYCURSOR;
			goto yy18;
		default: goto yy8;
	}
yy20:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy35;
		case ':': goto yy36;
		case 'v': goto yy37;
		default: goto yy8;
	}
yy21:
	yych = *++YYCURSOR;
	switch (yych) {
		case 'P': goto yy38;
		default: goto yy10;
	}
yy22:
	yych = *++YYCURSOR;
	switch (yych) {
		case 'T': goto yy39;
		default: goto yy8;
	}
yy23:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy13;
		default: goto yy8;
	}
yy24:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy40;
		default: goto yy8;
	}
yy25:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 60) YYFILL(60);
	yych = *YYCURSOR;
yy26:
	switch (yych) {
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy25;
		case '%': goto yy27;
		case '@':
			in->yyt9 = YYCURSOR;
			goto yy18;
		default: goto yy8;
	}
yy27:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy41;
		default: goto yy8;
	}
yy28:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 60) YYFILL(60);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt5 = YYCURSOR;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy25;
		case '%': goto yy27;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy28;
		case '@':
			in->yyt9 = YYCURSOR;
			goto yy18;
		default: goto yy8;
	}
yy29:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 11) YYFILL(11);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = YYCURSOR;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '/':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case '?':
		case '@':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy29;
		case '%': goto yy30;
		default: goto yy8;
	}
yy30:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy42;
		default: goto yy8;
	}
yy31:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 12) YYFILL(12);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt4 = in->yyt5;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt11 = YYCURSOR;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy31;
		case '%': goto yy32;
		case ':':
			in->yyt11 = YYCURSOR;
			goto yy33;
		default: goto yy8;
	}
yy32:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy43;
		default: goto yy8;
	}
yy33:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt4 = in->yyt5;
			in->yyt5 = YYCURSOR;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt12 = YYCURSOR;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			in->yyt12 = YYCURSOR;
			goto yy44;
		default: goto yy8;
	}
yy34:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt5 = YYCURSOR;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt12 = YYCURSOR;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~':
			in->yyt23 = YYCURSOR;
			goto yy45;
		case '%':
			in->yyt23 = YYCURSOR;
			goto yy46;
		case '/':
			in->yyt23 = YYCURSOR;
			goto yy47;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			in->yyt12 = YYCURSOR;
			in->yyt23 = YYCURSOR;
			goto yy48;
		case '?':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = YYCURSOR;
			in->yyt24 = YYCURSOR;
			goto yy49;
		case '@':
			in->yyt9 = YYCURSOR;
			in->yyt23 = YYCURSOR;
			goto yy50;
		default: goto yy8;
	}
yy35:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy51;
		case ':': goto yy52;
		default: goto yy8;
	}
yy36:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy53;
		default: goto yy8;
	}
yy37:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy8;
		default: goto yy55;
	}
yy38:
	yych = *++YYCURSOR;
	switch (yych) {
		case '/': goto yy56;
		default: goto yy10;
	}
yy39:
	yych = *++YYCURSOR;
	switch (yych) {
		case 'T': goto yy57;
		default: goto yy8;
	}
yy40:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy15;
		default: goto yy8;
	}
yy41:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy25;
		default: goto yy8;
	}
yy42:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy29;
		default: goto yy8;
	}
yy43:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy31;
		default: goto yy8;
	}
yy44:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 11) YYFILL(11);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt4 = in->yyt5;
			in->yyt5 = YYCURSOR;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy44;
		default: goto yy8;
	}
yy45:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 60) YYFILL(60);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt24 = YYCURSOR;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy45;
		case '%': goto yy46;
		case '/': goto yy58;
		case '?':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt24 = YYCURSOR;
			goto yy49;
		case '@':
			in->yyt9 = YYCURSOR;
			goto yy50;
		default: goto yy8;
	}
yy46:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy60;
		default: goto yy8;
	}
yy47:
	yych = *++YYCURSOR;
	switch (yych) {
		case '/': goto yy62;
		default: goto yy59;
	}
yy48:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 60) YYFILL(60);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt5 = YYCURSOR;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy45;
		case '%': goto yy46;
		case '/': goto yy58;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy48;
		case '?':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt24 = YYCURSOR;
			goto yy49;
		case '@':
			in->yyt9 = YYCURSOR;
			goto yy50;
		default: goto yy8;
	}
yy49:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = YYCURSOR;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt25 = YYCURSOR;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '/':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case '?':
		case '@':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~':
			in->yyt25 = YYCURSOR;
			goto yy63;
		case '%':
			in->yyt25 = YYCURSOR;
			goto yy64;
		default: goto yy8;
	}
yy50:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt4 = in->yyt5;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt10 = YYCURSOR;
			in->yyt11 = YYCURSOR;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~':
			in->yyt10 = YYCURSOR;
			goto yy65;
		case '%':
			in->yyt10 = YYCURSOR;
			goto yy67;
		case ':':
			in->yyt10 = YYCURSOR;
			in->yyt11 = YYCURSOR;
			goto yy68;
		case '[':
			in->yyt4 = in->yyt5;
			in->yyt10 = YYCURSOR;
			goto yy20;
		default: goto yy66;
	}
yy51:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy69;
		case ':': goto yy52;
		default: goto yy8;
	}
yy52:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy70;
		case ':': goto yy71;
		default: goto yy8;
	}
yy53:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy72;
		case '1': goto yy73;
		case '2': goto yy74;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy75;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy76;
		case ']': goto yy77;
		default: goto yy8;
	}
yy54:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy55:
	switch (yych) {
		case '.': goto yy78;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy54;
		default: goto yy8;
	}
yy56:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy79;
		default: goto yy8;
	}
yy57:
	yych = *++YYCURSOR;
	switch (yych) {
		case 'P': goto yy80;
		default: goto yy8;
	}
yy58:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 12) YYFILL(12);
	yych = *YYCURSOR;
yy59:
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt24 = YYCURSOR;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '/':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case '@':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy58;
		case '%': goto yy61;
		case '?':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt24 = YYCURSOR;
			goto yy49;
		default: goto yy8;
	}
yy60:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy45;
		default: goto yy8;
	}
yy61:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy81;
		default: goto yy8;
	}
yy62:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = YYCURSOR;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~':
			in->yyt3 = YYCURSOR;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = YYCURSOR;
			goto yy82;
		case '%':
			in->yyt3 = YYCURSOR;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = YYCURSOR;
			goto yy83;
		case '/':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = YYCURSOR;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case ':':
			in->yyt3 = YYCURSOR;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = YYCURSOR;
			in->yyt18 = YYCURSOR;
			goto yy85;
		case '?':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = YYCURSOR;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		case '@':
			in->yyt3 = YYCURSOR;
			in->yyt16 = YYCURSOR;
			goto yy86;
		case '[':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = YYCURSOR;
			goto yy87;
		default: goto yy8;
	}
yy63:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 11) YYFILL(11);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = YYCURSOR;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '/':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case '?':
		case '@':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy63;
		case '%': goto yy64;
		default: goto yy8;
	}
yy64:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy88;
		default: goto yy8;
	}
yy65:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 13) YYFILL(13);
	yych = *YYCURSOR;
yy66:
	switch (yych) {
		case ' ':
			in->yyt4 = in->yyt5;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt11 = YYCURSOR;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy65;
		case '%': goto yy67;
		case '/':
		case '@': goto yy58;
		case ':':
			in->yyt11 = YYCURSOR;
			goto yy68;
		case '?':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt24 = YYCURSOR;
			goto yy49;
		default: goto yy8;
	}
yy67:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy89;
		default: goto yy8;
	}
yy68:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt4 = in->yyt5;
			in->yyt5 = YYCURSOR;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt12 = YYCURSOR;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			in->yyt12 = YYCURSOR;
			goto yy90;
		default: goto yy59;
	}
yy69:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy91;
		case ':': goto yy52;
		default: goto yy8;
	}
yy70:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy92;
		case ':': goto yy93;
		default: goto yy8;
	}
yy71:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy94;
		case '1': goto yy95;
		case '2': goto yy96;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy97;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy98;
		case ']': goto yy77;
		default: goto yy8;
	}
yy72:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy100;
		case ':': goto yy101;
		case ']': goto yy77;
		default: goto yy8;
	}
yy73:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy102;
		case ':': goto yy101;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy100;
		case ']': goto yy77;
		default: goto yy8;
	}
yy74:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy102;
		case '5': goto yy103;
		case '6':
		case '7':
		case '8':
		case '9': goto yy104;
		case ':': goto yy101;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy100;
		case ']': goto yy77;
		default: goto yy8;
	}
yy75:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy104;
		case ':': goto yy101;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy100;
		case ']': goto yy77;
		default: goto yy8;
	}
yy76:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy100;
		case ':': goto yy101;
		case ']': goto yy77;
		default: goto yy8;
	}
yy77:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt11 = YYCURSOR;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case ':':
			in->yyt5 = in->yyt4;
			in->yyt11 = YYCURSOR;
			goto yy33;
		default: goto yy8;
	}
yy78:
	yych = *++YYCURSOR;
	switch (yych) {
		case ']': goto yy8;
		default: goto yy106;
	}
yy79:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy107;
		default: goto yy8;
	}
yy80:
	yych = *++YYCURSOR;
	switch (yych) {
		case '/': goto yy108;
		default: goto yy8;
	}
yy81:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy58;
		default: goto yy8;
	}
yy82:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 62) YYFILL(62);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy82;
		case '%': goto yy83;
		case '/':
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case ':':
			in->yyt18 = YYCURSOR;
			goto yy85;
		case '?':
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		case '@':
			in->yyt16 = YYCURSOR;
			goto yy86;
		default: goto yy8;
	}
yy83:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy109;
		default: goto yy8;
	}
yy84:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 12) YYFILL(12);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '/':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case '@':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy84;
		case '%': goto yy110;
		case '?':
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		default: goto yy8;
	}
yy85:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt19 = YYCURSOR;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '/':
			in->yyt19 = YYCURSOR;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			in->yyt19 = YYCURSOR;
			goto yy114;
		case '?':
			in->yyt19 = YYCURSOR;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		default: goto yy112;
	}
yy86:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt15 = in->yyt3;
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt17 = YYCURSOR;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~':
			in->yyt17 = YYCURSOR;
			goto yy115;
		case '%':
			in->yyt17 = YYCURSOR;
			goto yy116;
		case '/':
			in->yyt15 = in->yyt3;
			in->yyt17 = YYCURSOR;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case ':':
			in->yyt17 = YYCURSOR;
			in->yyt18 = YYCURSOR;
			goto yy117;
		case '?':
			in->yyt15 = in->yyt3;
			in->yyt17 = YYCURSOR;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		case '[':
			in->yyt15 = in->yyt3;
			in->yyt17 = YYCURSOR;
			goto yy87;
		default: goto yy8;
	}
yy87:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy118;
		case ':': goto yy119;
		case 'v': goto yy120;
		default: goto yy8;
	}
yy88:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy63;
		default: goto yy8;
	}
yy89:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy65;
		default: goto yy8;
	}
yy90:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 12) YYFILL(12);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt4 = in->yyt5;
			in->yyt5 = YYCURSOR;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '/':
		case ':':
		case ';':
		case '=':
		case '@':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy58;
		case '%': goto yy61;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy90;
		case '?':
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt24 = YYCURSOR;
			goto yy49;
		default: goto yy8;
	}
yy91:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy52;
		default: goto yy8;
	}
yy92:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy121;
		case ':': goto yy93;
		default: goto yy8;
	}
yy93:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy122;
		case ':': goto yy123;
		default: goto yy8;
	}
yy94:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy124;
		case ':': goto yy125;
		case ']': goto yy77;
		default: goto yy8;
	}
yy95:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy126;
		case ':': goto yy125;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy124;
		case ']': goto yy77;
		default: goto yy8;
	}
yy96:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy126;
		case '5': goto yy127;
		case '6':
		case '7':
		case '8':
		case '9': goto yy128;
		case ':': goto yy125;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy124;
		case ']': goto yy77;
		default: goto yy8;
	}
yy97:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy128;
		case ':': goto yy125;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy124;
		case ']': goto yy77;
		default: goto yy8;
	}
yy98:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy124;
		case ':': goto yy125;
		case ']': goto yy77;
		default: goto yy8;
	}
yy99:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy129;
		case '1': goto yy130;
		case '2': goto yy131;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy132;
		default: goto yy8;
	}
yy100:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy133;
		case ':': goto yy101;
		case ']': goto yy77;
		default: goto yy8;
	}
yy101:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy94;
		case '1': goto yy95;
		case '2': goto yy96;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy97;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy98;
		default: goto yy8;
	}
yy102:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy134;
		case ':': goto yy101;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy133;
		case ']': goto yy77;
		default: goto yy8;
	}
yy103:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy134;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy133;
		case ':': goto yy101;
		case ']': goto yy77;
		default: goto yy8;
	}
yy104:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy133;
		case ':': goto yy101;
		case ']': goto yy77;
		default: goto yy8;
	}
yy105:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 13) YYFILL(13);
	yych = *YYCURSOR;
yy106:
	switch (yych) {
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy105;
		case ']': goto yy77;
		default: goto yy8;
	}
yy107:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy135;
		default: goto yy8;
	}
yy108:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy136;
		default: goto yy8;
	}
yy109:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy82;
		default: goto yy8;
	}
yy110:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy137;
		default: goto yy8;
	}
yy111:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 61) YYFILL(61);
	yych = *YYCURSOR;
yy112:
	switch (yych) {
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy111;
		case '%': goto yy113;
		case '@':
			in->yyt16 = YYCURSOR;
			goto yy86;
		default: goto yy8;
	}
yy113:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy138;
		default: goto yy8;
	}
yy114:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 61) YYFILL(61);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy111;
		case '%': goto yy113;
		case '/':
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy114;
		case '?':
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		case '@':
			in->yyt16 = YYCURSOR;
			goto yy86;
		default: goto yy8;
	}
yy115:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 13) YYFILL(13);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt15 = in->yyt3;
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy115;
		case '%': goto yy116;
		case '/':
			in->yyt15 = in->yyt3;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case ':':
			in->yyt18 = YYCURSOR;
			goto yy117;
		case '?':
			in->yyt15 = in->yyt3;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		default: goto yy8;
	}
yy116:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy139;
		default: goto yy8;
	}
yy117:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt15 = in->yyt3;
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt19 = YYCURSOR;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '/':
			in->yyt15 = in->yyt3;
			in->yyt19 = YYCURSOR;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			in->yyt19 = YYCURSOR;
			goto yy140;
		case '?':
			in->yyt15 = in->yyt3;
			in->yyt19 = YYCURSOR;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		default: goto yy8;
	}
yy118:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy141;
		case ':': goto yy142;
		default: goto yy8;
	}
yy119:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy143;
		default: goto yy8;
	}
yy120:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy8;
		default: goto yy145;
	}
yy121:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy146;
		case ':': goto yy93;
		default: goto yy8;
	}
yy122:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy147;
		case ':': goto yy148;
		default: goto yy8;
	}
yy123:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy149;
		case '1': goto yy150;
		case '2': goto yy151;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy152;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy153;
		case ']': goto yy77;
		default: goto yy8;
	}
yy124:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy154;
		case ':': goto yy125;
		case ']': goto yy77;
		default: goto yy8;
	}
yy125:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy149;
		case '1': goto yy150;
		case '2': goto yy151;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy152;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy153;
		default: goto yy8;
	}
yy126:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy155;
		case ':': goto yy125;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy154;
		case ']': goto yy77;
		default: goto yy8;
	}
yy127:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy155;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy154;
		case ':': goto yy125;
		case ']': goto yy77;
		default: goto yy8;
	}
yy128:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy154;
		case ':': goto yy125;
		case ']': goto yy77;
		default: goto yy8;
	}
yy129:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy156;
		default: goto yy8;
	}
yy130:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy156;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy132;
		default: goto yy8;
	}
yy131:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy156;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy132;
		case '5': goto yy157;
		case '6':
		case '7':
		case '8':
		case '9': goto yy129;
		default: goto yy8;
	}
yy132:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy156;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy129;
		default: goto yy8;
	}
yy133:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy158;
		case ':': goto yy101;
		case ']': goto yy77;
		default: goto yy8;
	}
yy134:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy158;
		case ':': goto yy101;
		case ']': goto yy77;
		default: goto yy8;
	}
yy135:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ': goto yy159;
		default: goto yy8;
	}
yy136:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy160;
		default: goto yy8;
	}
yy137:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy84;
		default: goto yy8;
	}
yy138:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy111;
		default: goto yy8;
	}
yy139:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy115;
		default: goto yy8;
	}
yy140:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 12) YYFILL(12);
	yych = *YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt15 = in->yyt3;
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '/':
			in->yyt15 = in->yyt3;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy140;
		case '?':
			in->yyt15 = in->yyt3;
			in->yyt20 = YYCURSOR;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		default: goto yy8;
	}
yy141:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy161;
		case ':': goto yy142;
		default: goto yy8;
	}
yy142:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy162;
		case ':': goto yy163;
		default: goto yy8;
	}
yy143:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy164;
		case '1': goto yy165;
		case '2': goto yy166;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy167;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy168;
		case ']': goto yy169;
		default: goto yy8;
	}
yy144:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy145:
	switch (yych) {
		case '.': goto yy170;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy144;
		default: goto yy8;
	}
yy146:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy93;
		default: goto yy8;
	}
yy147:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy171;
		case ':': goto yy148;
		default: goto yy8;
	}
yy148:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy172;
		case ':': goto yy173;
		default: goto yy8;
	}
yy149:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy174;
		case ':': goto yy175;
		case ']': goto yy77;
		default: goto yy8;
	}
yy150:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy176;
		case ':': goto yy175;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy174;
		case ']': goto yy77;
		default: goto yy8;
	}
yy151:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy176;
		case '5': goto yy177;
		case '6':
		case '7':
		case '8':
		case '9': goto yy178;
		case ':': goto yy175;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy174;
		case ']': goto yy77;
		default: goto yy8;
	}
yy152:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy178;
		case ':': goto yy175;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy174;
		case ']': goto yy77;
		default: goto yy8;
	}
yy153:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy174;
		case ':': goto yy175;
		case ']': goto yy77;
		default: goto yy8;
	}
yy154:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy179;
		case ':': goto yy125;
		case ']': goto yy77;
		default: goto yy8;
	}
yy155:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy179;
		case ':': goto yy125;
		case ']': goto yy77;
		default: goto yy8;
	}
yy156:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy180;
		case '1': goto yy181;
		case '2': goto yy182;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy183;
		default: goto yy8;
	}
yy157:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy156;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy129;
		default: goto yy8;
	}
yy158:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy101;
		case ']': goto yy77;
		default: goto yy8;
	}
yy159:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy184;
		default: goto yy8;
	}
yy160:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy185;
		default: goto yy8;
	}
yy161:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy186;
		case ':': goto yy142;
		default: goto yy8;
	}
yy162:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy187;
		case ':': goto yy188;
		default: goto yy8;
	}
yy163:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy189;
		case '1': goto yy190;
		case '2': goto yy191;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy192;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy193;
		case ']': goto yy169;
		default: goto yy8;
	}
yy164:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy195;
		case ':': goto yy196;
		case ']': goto yy169;
		default: goto yy8;
	}
yy165:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy197;
		case ':': goto yy196;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy195;
		case ']': goto yy169;
		default: goto yy8;
	}
yy166:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy197;
		case '5': goto yy198;
		case '6':
		case '7':
		case '8':
		case '9': goto yy199;
		case ':': goto yy196;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy195;
		case ']': goto yy169;
		default: goto yy8;
	}
yy167:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy199;
		case ':': goto yy196;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy195;
		case ']': goto yy169;
		default: goto yy8;
	}
yy168:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy195;
		case ':': goto yy196;
		case ']': goto yy169;
		default: goto yy8;
	}
yy169:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ':
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy12;
		case '/':
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			goto yy84;
		case ':':
			in->yyt3 = in->yyt15;
			in->yyt18 = YYCURSOR;
			goto yy117;
		case '?':
			in->yyt18 = YYCURSOR;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = YYCURSOR;
			in->yyt22 = YYCURSOR;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			goto yy49;
		default: goto yy8;
	}
yy170:
	yych = *++YYCURSOR;
	switch (yych) {
		case ']': goto yy8;
		default: goto yy201;
	}
yy171:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy202;
		case ':': goto yy148;
		default: goto yy8;
	}
yy172:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy203;
		case ':': goto yy204;
		default: goto yy8;
	}
yy173:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy205;
		case '1': goto yy206;
		case '2': goto yy207;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy208;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy209;
		case ']': goto yy77;
		default: goto yy8;
	}
yy174:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy210;
		case ':': goto yy175;
		case ']': goto yy77;
		default: goto yy8;
	}
yy175:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy205;
		case '1': goto yy206;
		case '2': goto yy207;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy208;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy209;
		default: goto yy8;
	}
yy176:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy211;
		case ':': goto yy175;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy210;
		case ']': goto yy77;
		default: goto yy8;
	}
yy177:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy211;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy210;
		case ':': goto yy175;
		case ']': goto yy77;
		default: goto yy8;
	}
yy178:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy210;
		case ':': goto yy175;
		case ']': goto yy77;
		default: goto yy8;
	}
yy179:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy125;
		case ']': goto yy77;
		default: goto yy8;
	}
yy180:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy212;
		default: goto yy8;
	}
yy181:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy212;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy183;
		default: goto yy8;
	}
yy182:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy212;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy183;
		case '5': goto yy213;
		case '6':
		case '7':
		case '8':
		case '9': goto yy180;
		default: goto yy8;
	}
yy183:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy212;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy180;
		default: goto yy8;
	}
yy184:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy214;
		default: goto yy8;
	}
yy185:
	yych = *++YYCURSOR;
	switch (yych) {
		case '\n':
			in->yyt8 = YYCURSOR;
			goto yy215;
		default: goto yy8;
	}
yy186:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy142;
		default: goto yy8;
	}
yy187:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy216;
		case ':': goto yy188;
		default: goto yy8;
	}
yy188:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy217;
		case ':': goto yy218;
		default: goto yy8;
	}
yy189:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy219;
		case ':': goto yy220;
		case ']': goto yy169;
		default: goto yy8;
	}
yy190:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy221;
		case ':': goto yy220;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy219;
		case ']': goto yy169;
		default: goto yy8;
	}
yy191:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy221;
		case '5': goto yy222;
		case '6':
		case '7':
		case '8':
		case '9': goto yy223;
		case ':': goto yy220;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy219;
		case ']': goto yy169;
		default: goto yy8;
	}
yy192:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy223;
		case ':': goto yy220;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy219;
		case ']': goto yy169;
		default: goto yy8;
	}
yy193:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy219;
		case ':': goto yy220;
		case ']': goto yy169;
		default: goto yy8;
	}
yy194:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy224;
		case '1': goto yy225;
		case '2': goto yy226;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy227;
		default: goto yy8;
	}
yy195:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy228;
		case ':': goto yy196;
		case ']': goto yy169;
		default: goto yy8;
	}
yy196:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy189;
		case '1': goto yy190;
		case '2': goto yy191;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy192;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy193;
		default: goto yy8;
	}
yy197:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy229;
		case ':': goto yy196;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy228;
		case ']': goto yy169;
		default: goto yy8;
	}
yy198:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy229;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy228;
		case ':': goto yy196;
		case ']': goto yy169;
		default: goto yy8;
	}
yy199:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy228;
		case ':': goto yy196;
		case ']': goto yy169;
		default: goto yy8;
	}
yy200:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 14) YYFILL(14);
	yych = *YYCURSOR;
yy201:
	switch (yych) {
		case '!':
		case '$':
		case '&':
		case '\'':
		case '(':
		case ')':
		case '*':
		case '+':
		case ',':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case ':':
		case ';':
		case '=':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '~': goto yy200;
		case ']': goto yy169;
		default: goto yy8;
	}
yy202:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy148;
		default: goto yy8;
	}
yy203:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy230;
		case ':': goto yy204;
		default: goto yy8;
	}
yy204:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy231;
		case ':': goto yy232;
		default: goto yy8;
	}
yy205:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy233;
		case ':': goto yy234;
		case ']': goto yy77;
		default: goto yy8;
	}
yy206:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy235;
		case ':': goto yy234;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy233;
		case ']': goto yy77;
		default: goto yy8;
	}
yy207:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy235;
		case '5': goto yy236;
		case '6':
		case '7':
		case '8':
		case '9': goto yy237;
		case ':': goto yy234;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy233;
		case ']': goto yy77;
		default: goto yy8;
	}
yy208:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy237;
		case ':': goto yy234;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy233;
		case ']': goto yy77;
		default: goto yy8;
	}
yy209:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy233;
		case ':': goto yy234;
		case ']': goto yy77;
		default: goto yy8;
	}
yy210:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy238;
		case ':': goto yy175;
		case ']': goto yy77;
		default: goto yy8;
	}
yy211:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy238;
		case ':': goto yy175;
		case ']': goto yy77;
		default: goto yy8;
	}
yy212:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy239;
		case '1': goto yy240;
		case '2': goto yy241;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy242;
		default: goto yy8;
	}
yy213:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy212;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy180;
		default: goto yy8;
	}
yy214:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy243;
		default: goto yy8;
	}
yy215:
	yych = *++YYCURSOR;
	switch (yych) {
		case '\n':
			YYMTAGN(in->yytm35);
			YYMTAGN(in->yytm34);
			YYMTAGN(in->yytm33);
			YYMTAGN(in->yytm32);
			YYMTAGN(in->yytm31);
			in->yyt29 = NULL;
			in->yyt30 = NULL;
			goto yy244;
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~':
			YYMTAGP(in->yytm31);
			in->yyt29 = NULL;
			in->yyt30 = NULL;
			goto yy245;
		default: goto yy8;
	}
yy216:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy246;
		case ':': goto yy188;
		default: goto yy8;
	}
yy217:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy247;
		case ':': goto yy248;
		default: goto yy8;
	}
yy218:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy249;
		case '1': goto yy250;
		case '2': goto yy251;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy252;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy253;
		case ']': goto yy169;
		default: goto yy8;
	}
yy219:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy254;
		case ':': goto yy220;
		case ']': goto yy169;
		default: goto yy8;
	}
yy220:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy249;
		case '1': goto yy250;
		case '2': goto yy251;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy252;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy253;
		default: goto yy8;
	}
yy221:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy255;
		case ':': goto yy220;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy254;
		case ']': goto yy169;
		default: goto yy8;
	}
yy222:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy255;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy254;
		case ':': goto yy220;
		case ']': goto yy169;
		default: goto yy8;
	}
yy223:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy254;
		case ':': goto yy220;
		case ']': goto yy169;
		default: goto yy8;
	}
yy224:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy256;
		default: goto yy8;
	}
yy225:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy256;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy227;
		default: goto yy8;
	}
yy226:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy256;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy227;
		case '5': goto yy257;
		case '6':
		case '7':
		case '8':
		case '9': goto yy224;
		default: goto yy8;
	}
yy227:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy256;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy224;
		default: goto yy8;
	}
yy228:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy258;
		case ':': goto yy196;
		case ']': goto yy169;
		default: goto yy8;
	}
yy229:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy258;
		case ':': goto yy196;
		case ']': goto yy169;
		default: goto yy8;
	}
yy230:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy259;
		case ':': goto yy204;
		default: goto yy8;
	}
yy231:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy260;
		case ':': goto yy261;
		default: goto yy8;
	}
yy232:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy262;
		case '1': goto yy263;
		case '2': goto yy264;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy265;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy266;
		case ']': goto yy77;
		default: goto yy8;
	}
yy233:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy267;
		case ':': goto yy234;
		case ']': goto yy77;
		default: goto yy8;
	}
yy234:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy262;
		case '1': goto yy263;
		case '2': goto yy264;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy265;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy266;
		default: goto yy8;
	}
yy235:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy268;
		case ':': goto yy234;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy267;
		case ']': goto yy77;
		default: goto yy8;
	}
yy236:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy268;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy267;
		case ':': goto yy234;
		case ']': goto yy77;
		default: goto yy8;
	}
yy237:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy267;
		case ':': goto yy234;
		case ']': goto yy77;
		default: goto yy8;
	}
yy238:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy175;
		case ']': goto yy77;
		default: goto yy8;
	}
yy239:
	yych = *++YYCURSOR;
	switch (yych) {
		case ']': goto yy77;
		default: goto yy8;
	}
yy240:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy242;
		case ']': goto yy77;
		default: goto yy8;
	}
yy241:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy242;
		case '5': goto yy269;
		case '6':
		case '7':
		case '8':
		case '9': goto yy239;
		case ']': goto yy77;
		default: goto yy8;
	}
yy242:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy239;
		case ']': goto yy77;
		default: goto yy8;
	}
yy243:
	yych = *++YYCURSOR;
	switch (yych) {
		case ' ': goto yy270;
		default: goto yy8;
	}
yy244:
	++YYCURSOR;
	m1 = in->yyt1;
	m2 = in->yyt2;
	at = in->yyt3;
	u3 = in->yyt4;
	u4 = in->yyt9;
	hs3 = in->yyt10;
	hs4 = in->yyt11;
	r3 = in->yyt12;
	r4 = in->yyt5;
	s1 = in->yyt13;
	s2 = in->yyt14;
	u1 = in->yyt15;
	u2 = in->yyt16;
	hs1 = in->yyt17;
	hs2 = in->yyt18;
	r1 = in->yyt19;
	r2 = in->yyt20;
	p1 = in->yyt21;
	p2 = in->yyt22;
	p3 = in->yyt23;
	p4 = in->yyt24;
	q1 = in->yyt25;
	q2 = in->yyt6;
	p5 = in->yyt26;
	p6 = in->yyt27;
	q3 = in->yyt28;
	q4 = in->yyt7;
	v4 = in->yyt8;
	rp1 = in->yyt29;
	rp2 = in->yyt30;
	h1 = in->yytm31;
	h2 = in->yytm32;
	h3 = in->yytm33;
	h4 = in->yytm34;
	h5 = in->yytm35;
	au = in->yyt13;
	of = in->yyt26;
	v3 = in->yyt8;
	v1 = in->yyt29;
	v2 = in->yyt29;
	st1 = in->yyt29;
	st2 = in->yyt29;
	if (v3 != NULL) v3 -= 8;
	if (v1 != NULL) v1 -= 13;
	if (v2 != NULL) v2 -= 5;
	if (st1 != NULL) st1 -= 4;
	if (st2 != NULL) st2 -= 1;
	{
        ++c;
        if (st1) {
            fprintf(stderr, "%.*s %.*s %.*s\n",
                (int)(v2 - v1), v1,
                (int)(st2 - st1), st1,
                (int)(rp2 - rp1), rp1);
        } else if (m1) {
            fprintf(stderr, "%.*s ", (int)(m2 - m1), m1);
            if (of) {
                fprintf(stderr, "%.*s", (int)(p6 - p5), p5);
                if (q3) fprintf(stderr, "?%.*s", (int)(q4 - q3), q3);
            } else if (au) {
                fprintf(stderr, "%.*s:", (int)(s2 - s1), s1);
                if (p1) fprintf(stderr, "//");
                if (u1) fprintf(stderr, "%.*s@", (int)(u2 - u1), u1);
                fprintf(stderr, "%.*s", (int)(hs2 - hs1), hs1);
                if (r1) fprintf(stderr, ":%.*s", (int)(r2 - r1), r1);
                if (p1) fprintf(stderr, "%.*s",  (int)(p2 - p1), p1);
                if (p3) fprintf(stderr, "%.*s",  (int)(p4 - p3), p3);
                if (q1) fprintf(stderr, "?%.*s", (int)(q2 - q1), q1);
            } else if (at) {
                if (u3) fprintf(stderr, "%.*s@", (int)(u4 - u3), u3);
                fprintf(stderr, "%.*s", (int)(hs4 - hs3), hs3);
                if (r3) fprintf(stderr, ":%.*s", (int)(r4 - r3), r3);
            } else {
                fprintf(stderr, "*");
            }
            fprintf(stderr, " %.*s\n", (int)(v4 - v3), v3);
        }
        print_headers(in->tok, h1, h2, h3, h4, h5);
        fprintf(stderr, "\n");
        mtagpool_clear(&in->mtp, in);
        goto loop;
    }
yy245:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~': goto yy245;
		case ':':
			YYMTAGP(in->yytm32);
			goto yy271;
		default: goto yy8;
	}
yy246:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy188;
		default: goto yy8;
	}
yy247:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy272;
		case ':': goto yy248;
		default: goto yy8;
	}
yy248:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy273;
		case ':': goto yy274;
		default: goto yy8;
	}
yy249:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy275;
		case ':': goto yy276;
		case ']': goto yy169;
		default: goto yy8;
	}
yy250:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy277;
		case ':': goto yy276;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy275;
		case ']': goto yy169;
		default: goto yy8;
	}
yy251:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy277;
		case '5': goto yy278;
		case '6':
		case '7':
		case '8':
		case '9': goto yy279;
		case ':': goto yy276;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy275;
		case ']': goto yy169;
		default: goto yy8;
	}
yy252:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy279;
		case ':': goto yy276;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy275;
		case ']': goto yy169;
		default: goto yy8;
	}
yy253:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy275;
		case ':': goto yy276;
		case ']': goto yy169;
		default: goto yy8;
	}
yy254:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy280;
		case ':': goto yy220;
		case ']': goto yy169;
		default: goto yy8;
	}
yy255:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy280;
		case ':': goto yy220;
		case ']': goto yy169;
		default: goto yy8;
	}
yy256:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy281;
		case '1': goto yy282;
		case '2': goto yy283;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy284;
		default: goto yy8;
	}
yy257:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy256;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy224;
		default: goto yy8;
	}
yy258:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy196;
		case ']': goto yy169;
		default: goto yy8;
	}
yy259:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy204;
		default: goto yy8;
	}
yy260:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy285;
		case ':': goto yy261;
		default: goto yy8;
	}
yy261:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy286;
		case ':': goto yy287;
		default: goto yy8;
	}
yy262:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy288;
		case ':': goto yy289;
		case ']': goto yy77;
		default: goto yy8;
	}
yy263:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy290;
		case ':': goto yy289;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy288;
		case ']': goto yy77;
		default: goto yy8;
	}
yy264:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy290;
		case '5': goto yy291;
		case '6':
		case '7':
		case '8':
		case '9': goto yy292;
		case ':': goto yy289;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy288;
		case ']': goto yy77;
		default: goto yy8;
	}
yy265:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy292;
		case ':': goto yy289;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy288;
		case ']': goto yy77;
		default: goto yy8;
	}
yy266:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy288;
		case ':': goto yy289;
		case ']': goto yy77;
		default: goto yy8;
	}
yy267:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy293;
		case ':': goto yy234;
		case ']': goto yy77;
		default: goto yy8;
	}
yy268:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy293;
		case ':': goto yy234;
		case ']': goto yy77;
		default: goto yy8;
	}
yy269:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy239;
		case ']': goto yy77;
		default: goto yy8;
	}
yy270:
	yych = *++YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\n':
			in->yyt29 = YYCURSOR;
			in->yyt30 = YYCURSOR;
			goto yy295;
		default:
			in->yyt29 = YYCURSOR;
			goto yy294;
	}
yy271:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t':
		case ' ': goto yy271;
		case '\n':
			in->yytm36 = in->yytm35;
			YYMTAGP(in->yytm36);
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			YYMTAGP(in->yytm33);
			goto yy296;
		default:
			YYMTAGP(in->yytm33);
			goto yy297;
	}
yy272:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy298;
		case ':': goto yy248;
		default: goto yy8;
	}
yy273:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy299;
		case ':': goto yy300;
		default: goto yy8;
	}
yy274:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy301;
		case '1': goto yy302;
		case '2': goto yy303;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy304;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy305;
		case ']': goto yy169;
		default: goto yy8;
	}
yy275:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy306;
		case ':': goto yy276;
		case ']': goto yy169;
		default: goto yy8;
	}
yy276:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy301;
		case '1': goto yy302;
		case '2': goto yy303;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy304;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy305;
		default: goto yy8;
	}
yy277:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy307;
		case ':': goto yy276;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy306;
		case ']': goto yy169;
		default: goto yy8;
	}
yy278:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy307;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy306;
		case ':': goto yy276;
		case ']': goto yy169;
		default: goto yy8;
	}
yy279:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy306;
		case ':': goto yy276;
		case ']': goto yy169;
		default: goto yy8;
	}
yy280:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy220;
		case ']': goto yy169;
		default: goto yy8;
	}
yy281:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy308;
		default: goto yy8;
	}
yy282:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy308;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy284;
		default: goto yy8;
	}
yy283:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy308;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy284;
		case '5': goto yy309;
		case '6':
		case '7':
		case '8':
		case '9': goto yy281;
		default: goto yy8;
	}
yy284:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy308;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy281;
		default: goto yy8;
	}
yy285:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy310;
		case ':': goto yy261;
		default: goto yy8;
	}
yy286:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy311;
		case ':': goto yy312;
		default: goto yy8;
	}
yy287:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy313;
		case '1': goto yy314;
		case '2': goto yy315;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy316;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy317;
		case ']': goto yy77;
		default: goto yy8;
	}
yy288:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy318;
		case ':': goto yy289;
		case ']': goto yy77;
		default: goto yy8;
	}
yy289:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy313;
		case '1': goto yy314;
		case '2': goto yy315;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy316;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy317;
		default: goto yy8;
	}
yy290:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy319;
		case ':': goto yy289;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy318;
		case ']': goto yy77;
		default: goto yy8;
	}
yy291:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy319;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy318;
		case ':': goto yy289;
		case ']': goto yy77;
		default: goto yy8;
	}
yy292:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy318;
		case ':': goto yy289;
		case ']': goto yy77;
		default: goto yy8;
	}
yy293:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy234;
		case ']': goto yy77;
		default: goto yy8;
	}
yy294:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\n':
			in->yyt30 = YYCURSOR;
			goto yy295;
		default: goto yy294;
	}
yy295:
	yych = *++YYCURSOR;
	switch (yych) {
		case '\n':
			YYMTAGN(in->yytm35);
			YYMTAGN(in->yytm34);
			YYMTAGN(in->yytm33);
			YYMTAGN(in->yytm32);
			YYMTAGN(in->yytm31);
			in->yyt1 = NULL;
			in->yyt2 = NULL;
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt8 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy244;
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~':
			YYMTAGP(in->yytm31);
			in->yyt1 = NULL;
			in->yyt2 = NULL;
			in->yyt3 = NULL;
			in->yyt4 = NULL;
			in->yyt5 = NULL;
			in->yyt6 = NULL;
			in->yyt7 = NULL;
			in->yyt8 = NULL;
			in->yyt9 = NULL;
			in->yyt10 = NULL;
			in->yyt11 = NULL;
			in->yyt12 = NULL;
			in->yyt13 = NULL;
			in->yyt14 = NULL;
			in->yyt15 = NULL;
			in->yyt16 = NULL;
			in->yyt17 = NULL;
			in->yyt18 = NULL;
			in->yyt19 = NULL;
			in->yyt20 = NULL;
			in->yyt21 = NULL;
			in->yyt22 = NULL;
			in->yyt23 = NULL;
			in->yyt24 = NULL;
			in->yyt25 = NULL;
			in->yyt26 = NULL;
			in->yyt27 = NULL;
			in->yyt28 = NULL;
			goto yy245;
		default: goto yy8;
	}
yy296:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy320;
		case '\n':
			in->yytm34 = in->yytm37;
			in->yytm35 = in->yytm36;
			goto yy244;
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~':
			in->yytm34 = in->yytm37;
			in->yytm35 = in->yytm36;
			YYMTAGP(in->yytm31);
			goto yy245;
		default: goto yy8;
	}
yy297:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t':
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			goto yy321;
		case '\n':
			in->yytm36 = in->yytm35;
			YYMTAGP(in->yytm36);
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			goto yy296;
		case ' ': goto yy322;
		default: goto yy297;
	}
yy298:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy248;
		default: goto yy8;
	}
yy299:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy323;
		case ':': goto yy300;
		default: goto yy8;
	}
yy300:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy324;
		case ':': goto yy325;
		default: goto yy8;
	}
yy301:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy326;
		case ':': goto yy327;
		case ']': goto yy169;
		default: goto yy8;
	}
yy302:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy328;
		case ':': goto yy327;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy326;
		case ']': goto yy169;
		default: goto yy8;
	}
yy303:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy328;
		case '5': goto yy329;
		case '6':
		case '7':
		case '8':
		case '9': goto yy330;
		case ':': goto yy327;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy326;
		case ']': goto yy169;
		default: goto yy8;
	}
yy304:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy330;
		case ':': goto yy327;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy326;
		case ']': goto yy169;
		default: goto yy8;
	}
yy305:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy326;
		case ':': goto yy327;
		case ']': goto yy169;
		default: goto yy8;
	}
yy306:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy331;
		case ':': goto yy276;
		case ']': goto yy169;
		default: goto yy8;
	}
yy307:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy331;
		case ':': goto yy276;
		case ']': goto yy169;
		default: goto yy8;
	}
yy308:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy332;
		case '1': goto yy333;
		case '2': goto yy334;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy335;
		default: goto yy8;
	}
yy309:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy308;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy281;
		default: goto yy8;
	}
yy310:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy261;
		default: goto yy8;
	}
yy311:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy336;
		case ':': goto yy312;
		default: goto yy8;
	}
yy312:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy337;
		case '1': goto yy338;
		case '2': goto yy339;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy340;
		case ':': goto yy341;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy342;
		default: goto yy8;
	}
yy313:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy343;
		case ':': goto yy344;
		case ']': goto yy77;
		default: goto yy8;
	}
yy314:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy345;
		case ':': goto yy344;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy343;
		case ']': goto yy77;
		default: goto yy8;
	}
yy315:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy345;
		case '5': goto yy346;
		case '6':
		case '7':
		case '8':
		case '9': goto yy347;
		case ':': goto yy344;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy343;
		case ']': goto yy77;
		default: goto yy8;
	}
yy316:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy347;
		case ':': goto yy344;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy343;
		case ']': goto yy77;
		default: goto yy8;
	}
yy317:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy343;
		case ':': goto yy344;
		case ']': goto yy77;
		default: goto yy8;
	}
yy318:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy348;
		case ':': goto yy289;
		case ']': goto yy77;
		default: goto yy8;
	}
yy319:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy348;
		case ':': goto yy289;
		case ']': goto yy77;
		default: goto yy8;
	}
yy320:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t':
		case ' ': goto yy320;
		case '\n':
			in->yytm36 = in->yytm35;
			YYMTAGP(in->yytm36);
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			goto yy296;
		default: goto yy297;
	}
yy321:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t': goto yy321;
		case '\n':
			YYMTAGP(in->yytm35);
			goto yy349;
		case ' ': goto yy322;
		default: goto yy350;
	}
yy322:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t':
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			goto yy321;
		case '\n':
			in->yytm36 = in->yytm35;
			YYMTAGP(in->yytm36);
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			goto yy296;
		case ' ': goto yy322;
		default: goto yy351;
	}
yy323:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy352;
		case ':': goto yy300;
		default: goto yy8;
	}
yy324:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy353;
		case ':': goto yy354;
		default: goto yy8;
	}
yy325:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy355;
		case '1': goto yy356;
		case '2': goto yy357;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy358;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy359;
		case ']': goto yy169;
		default: goto yy8;
	}
yy326:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy360;
		case ':': goto yy327;
		case ']': goto yy169;
		default: goto yy8;
	}
yy327:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy355;
		case '1': goto yy356;
		case '2': goto yy357;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy358;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy359;
		default: goto yy8;
	}
yy328:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy361;
		case ':': goto yy327;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy360;
		case ']': goto yy169;
		default: goto yy8;
	}
yy329:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy361;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy360;
		case ':': goto yy327;
		case ']': goto yy169;
		default: goto yy8;
	}
yy330:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy360;
		case ':': goto yy327;
		case ']': goto yy169;
		default: goto yy8;
	}
yy331:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy276;
		case ']': goto yy169;
		default: goto yy8;
	}
yy332:
	yych = *++YYCURSOR;
	switch (yych) {
		case ']': goto yy169;
		default: goto yy8;
	}
yy333:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy335;
		case ']': goto yy169;
		default: goto yy8;
	}
yy334:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy335;
		case '5': goto yy362;
		case '6':
		case '7':
		case '8':
		case '9': goto yy332;
		case ']': goto yy169;
		default: goto yy8;
	}
yy335:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy332;
		case ']': goto yy169;
		default: goto yy8;
	}
yy336:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy363;
		case ':': goto yy312;
		default: goto yy8;
	}
yy337:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy364;
		case ':': goto yy365;
		default: goto yy8;
	}
yy338:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy366;
		case ':': goto yy365;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy364;
		default: goto yy8;
	}
yy339:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy366;
		case '5': goto yy367;
		case '6':
		case '7':
		case '8':
		case '9': goto yy368;
		case ':': goto yy365;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy364;
		default: goto yy8;
	}
yy340:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy368;
		case ':': goto yy365;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy364;
		default: goto yy8;
	}
yy341:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy369;
		case ']': goto yy77;
		default: goto yy8;
	}
yy342:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy364;
		case ':': goto yy365;
		default: goto yy8;
	}
yy343:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy370;
		case ':': goto yy344;
		case ']': goto yy77;
		default: goto yy8;
	}
yy344:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy369;
		default: goto yy8;
	}
yy345:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy371;
		case ':': goto yy344;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy370;
		case ']': goto yy77;
		default: goto yy8;
	}
yy346:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy371;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy370;
		case ':': goto yy344;
		case ']': goto yy77;
		default: goto yy8;
	}
yy347:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy370;
		case ':': goto yy344;
		case ']': goto yy77;
		default: goto yy8;
	}
yy348:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy289;
		case ']': goto yy77;
		default: goto yy8;
	}
yy349:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\n':
			in->yytm34 = in->yytm37;
			goto yy244;
		case '!':
		case '#':
		case '$':
		case '%':
		case '&':
		case '\'':
		case '*':
		case '+':
		case '-':
		case '.':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '^':
		case '_':
		case '`':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z':
		case '|':
		case '~':
			in->yytm34 = in->yytm37;
			YYMTAGP(in->yytm31);
			goto yy245;
		default: goto yy8;
	}
yy350:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t':
			YYMTAGP(in->yytm34);
			goto yy372;
		case '\n':
			in->yytm36 = in->yytm35;
			YYMTAGP(in->yytm36);
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			goto yy296;
		default: goto yy297;
	}
yy351:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t':
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			goto yy373;
		case '\n':
			in->yytm36 = in->yytm35;
			YYMTAGP(in->yytm36);
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm37);
			goto yy296;
		default: goto yy297;
	}
yy352:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy300;
		default: goto yy8;
	}
yy353:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy374;
		case ':': goto yy354;
		default: goto yy8;
	}
yy354:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy375;
		case ':': goto yy376;
		default: goto yy8;
	}
yy355:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy377;
		case ':': goto yy378;
		case ']': goto yy169;
		default: goto yy8;
	}
yy356:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy379;
		case ':': goto yy378;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy377;
		case ']': goto yy169;
		default: goto yy8;
	}
yy357:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy379;
		case '5': goto yy380;
		case '6':
		case '7':
		case '8':
		case '9': goto yy381;
		case ':': goto yy378;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy377;
		case ']': goto yy169;
		default: goto yy8;
	}
yy358:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy381;
		case ':': goto yy378;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy377;
		case ']': goto yy169;
		default: goto yy8;
	}
yy359:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy377;
		case ':': goto yy378;
		case ']': goto yy169;
		default: goto yy8;
	}
yy360:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy382;
		case ':': goto yy327;
		case ']': goto yy169;
		default: goto yy8;
	}
yy361:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy382;
		case ':': goto yy327;
		case ']': goto yy169;
		default: goto yy8;
	}
yy362:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy332;
		case ']': goto yy169;
		default: goto yy8;
	}
yy363:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy312;
		default: goto yy8;
	}
yy364:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy383;
		case ':': goto yy365;
		default: goto yy8;
	}
yy365:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy369;
		case ':': goto yy239;
		default: goto yy8;
	}
yy366:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy384;
		case ':': goto yy365;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy383;
		default: goto yy8;
	}
yy367:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy384;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy383;
		case ':': goto yy365;
		default: goto yy8;
	}
yy368:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy383;
		case ':': goto yy365;
		default: goto yy8;
	}
yy369:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy385;
		case ']': goto yy77;
		default: goto yy8;
	}
yy370:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy386;
		case ':': goto yy344;
		case ']': goto yy77;
		default: goto yy8;
	}
yy371:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy386;
		case ':': goto yy344;
		case ']': goto yy77;
		default: goto yy8;
	}
yy372:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy372;
		case '\n':
			in->yytm37 = in->yytm34;
			YYMTAGP(in->yytm35);
			goto yy349;
		default: goto yy8;
	}
yy373:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t': goto yy373;
		case '\n':
			YYMTAGP(in->yytm35);
			goto yy349;
		case ' ': goto yy387;
		default: goto yy350;
	}
yy374:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy388;
		case ':': goto yy354;
		default: goto yy8;
	}
yy375:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy389;
		case ':': goto yy390;
		default: goto yy8;
	}
yy376:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy391;
		case '1': goto yy392;
		case '2': goto yy393;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy394;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy395;
		case ']': goto yy169;
		default: goto yy8;
	}
yy377:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy396;
		case ':': goto yy378;
		case ']': goto yy169;
		default: goto yy8;
	}
yy378:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy391;
		case '1': goto yy392;
		case '2': goto yy393;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy394;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy395;
		default: goto yy8;
	}
yy379:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy397;
		case ':': goto yy378;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy396;
		case ']': goto yy169;
		default: goto yy8;
	}
yy380:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy397;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy396;
		case ':': goto yy378;
		case ']': goto yy169;
		default: goto yy8;
	}
yy381:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy396;
		case ':': goto yy378;
		case ']': goto yy169;
		default: goto yy8;
	}
yy382:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy327;
		case ']': goto yy169;
		default: goto yy8;
	}
yy383:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy398;
		case ':': goto yy365;
		default: goto yy8;
	}
yy384:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy99;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy398;
		case ':': goto yy365;
		default: goto yy8;
	}
yy385:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy399;
		case ']': goto yy77;
		default: goto yy8;
	}
yy386:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy344;
		case ']': goto yy77;
		default: goto yy8;
	}
yy387:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x7F: goto yy8;
		case '\t': goto yy373;
		case '\n':
			in->yytm36 = in->yytm35;
			YYMTAGP(in->yytm36);
			goto yy296;
		case ' ': goto yy387;
		default: goto yy351;
	}
yy388:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy354;
		default: goto yy8;
	}
yy389:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy400;
		case ':': goto yy390;
		default: goto yy8;
	}
yy390:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0': goto yy401;
		case '1': goto yy402;
		case '2': goto yy403;
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy404;
		case ':': goto yy405;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy406;
		default: goto yy8;
	}
yy391:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy407;
		case ':': goto yy408;
		case ']': goto yy169;
		default: goto yy8;
	}
yy392:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy409;
		case ':': goto yy408;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy407;
		case ']': goto yy169;
		default: goto yy8;
	}
yy393:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy409;
		case '5': goto yy410;
		case '6':
		case '7':
		case '8':
		case '9': goto yy411;
		case ':': goto yy408;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy407;
		case ']': goto yy169;
		default: goto yy8;
	}
yy394:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy411;
		case ':': goto yy408;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy407;
		case ']': goto yy169;
		default: goto yy8;
	}
yy395:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy407;
		case ':': goto yy408;
		case ']': goto yy169;
		default: goto yy8;
	}
yy396:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy412;
		case ':': goto yy378;
		case ']': goto yy169;
		default: goto yy8;
	}
yy397:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy412;
		case ':': goto yy378;
		case ']': goto yy169;
		default: goto yy8;
	}
yy398:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy365;
		default: goto yy8;
	}
yy399:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy239;
		case ']': goto yy77;
		default: goto yy8;
	}
yy400:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy413;
		case ':': goto yy390;
		default: goto yy8;
	}
yy401:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy414;
		case ':': goto yy415;
		default: goto yy8;
	}
yy402:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy416;
		case ':': goto yy415;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy414;
		default: goto yy8;
	}
yy403:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4': goto yy416;
		case '5': goto yy417;
		case '6':
		case '7':
		case '8':
		case '9': goto yy418;
		case ':': goto yy415;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy414;
		default: goto yy8;
	}
yy404:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy418;
		case ':': goto yy415;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy414;
		default: goto yy8;
	}
yy405:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy419;
		case ']': goto yy169;
		default: goto yy8;
	}
yy406:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy414;
		case ':': goto yy415;
		default: goto yy8;
	}
yy407:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy420;
		case ':': goto yy408;
		case ']': goto yy169;
		default: goto yy8;
	}
yy408:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy419;
		default: goto yy8;
	}
yy409:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy421;
		case ':': goto yy408;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy420;
		case ']': goto yy169;
		default: goto yy8;
	}
yy410:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy421;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy420;
		case ':': goto yy408;
		case ']': goto yy169;
		default: goto yy8;
	}
yy411:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy420;
		case ':': goto yy408;
		case ']': goto yy169;
		default: goto yy8;
	}
yy412:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy378;
		case ']': goto yy169;
		default: goto yy8;
	}
yy413:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy390;
		default: goto yy8;
	}
yy414:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy422;
		case ':': goto yy415;
		default: goto yy8;
	}
yy415:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy419;
		case ':': goto yy332;
		default: goto yy8;
	}
yy416:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': goto yy423;
		case ':': goto yy415;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy422;
		default: goto yy8;
	}
yy417:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5': goto yy423;
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy422;
		case ':': goto yy415;
		default: goto yy8;
	}
yy418:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy422;
		case ':': goto yy415;
		default: goto yy8;
	}
yy419:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy424;
		case ']': goto yy169;
		default: goto yy8;
	}
yy420:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy425;
		case ':': goto yy408;
		case ']': goto yy169;
		default: goto yy8;
	}
yy421:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy425;
		case ':': goto yy408;
		case ']': goto yy169;
		default: goto yy8;
	}
yy422:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy426;
		case ':': goto yy415;
		default: goto yy8;
	}
yy423:
	yych = *++YYCURSOR;
	switch (yych) {
		case '.': goto yy194;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy426;
		case ':': goto yy415;
		default: goto yy8;
	}
yy424:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy427;
		case ']': goto yy169;
		default: goto yy8;
	}
yy425:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy408;
		case ']': goto yy169;
		default: goto yy8;
	}
yy426:
	yych = *++YYCURSOR;
	switch (yych) {
		case ':': goto yy415;
		default: goto yy8;
	}
yy427:
	yych = *++YYCURSOR;
	switch (yych) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f': goto yy332;
		case ']': goto yy169;
		default: goto yy8;
	}
}

}

int main(int argc, char **argv)
{
    const char *fname = "input";
    FILE *f;

    // prepare input file
    f = fopen(fname, "w");
    fprintf(f,
        "GET /index.html HTTP/1.1\n"
        "Host: www.example.com\n"
        "User-Agent: Mozilla/5.0\n"
        "Accept: text/xml,application/xml,application/xhtml+xml,text/html*/*\n"
        "Accept-Language: en-us\n"
        "Accept-Charset: ISO-8859-1,utf-8\n"
        "Connection: keep-alive\n"
        "\n"
        "HTTP/1.1 200 OK\n"
        "Date: Thu, 24 Jul 2008 17:36:27 GMT\n"
        "Server: Apache-Coyote/1.1\n"
        "Content-Type: text/html;charset=UTF-8\n"
        "Content-Length: 1846\n"
        "\n");
    fclose(f);

    // read input into buffer
    input_t in;
    init_input(&in, fname);
    long count;

    assert(lex(&in, &count) == 0 && count == 2);

    // cleanup
    remove(fname);
    free_input(&in);
    return 0;
}
c/submatch/http_rfc7230.re:247:17: warning: tag `m1` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `at` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `u3` has 3rd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `u4` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `hs3` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `hs4` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `r3` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `s1` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `s2` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `u1` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `u2` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `hs1` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `hs2` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `r1` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `p3` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `h3` has 3rd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `h4` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
c/submatch/http_rfc7230.re:247:17: warning: tag `h5` has 2nd degree of nondeterminism [-Wnondeterministic-tags]
